require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/custom_fields', type: :request do
  let(:valid_attributes) { {rca_id: rca.id} }
  let(:invalid_attributes) { {rca_id: nil} }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:rca) { FactoryBot.create(:rca, methodology_id: methodology.id) }

  before :each do
    # puts user.email
    # puts User.count
    # User.all.each do |user|
    #   p(user)
    # end
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      CustomField.create! valid_attributes
      get custom_fields_url
      expect(response).to be_successful
    end
  end

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     custom_field = CustomField.create! valid_attributes
  #     get custom_field_url(custom_field)
  #     expect(response).to be_successful
  #   end
  # end

  # describe 'GET /new' do
  #   it 'renders a successful response' do
  #     get new_custom_field_url
  #     expect(response).to be_successful
  #   end
  # end

  # describe 'GET /edit' do
  #   it 'render a successful response' do
  #     custom_field = CustomField.create! valid_attributes
  #     get edit_custom_field_url(custom_field)
  #     expect(response).to be_successful
  #   end
  # end

  # describe 'POST /create' do
  #   context 'with valid parameters' do
  #     it 'creates a new CustomField' do
  #       expect {
  #         post custom_fields_url, params: { custom_field: valid_attributes }
  #       }.to change(CustomField, :count).by(1)
  #     end

  #     it 'redirects to the created custom_field' do
  #       post custom_fields_url, params: { custom_field: valid_attributes }
  #       expect(response).to redirect_to(custom_fields_url)
  #     end
  #   end

  #   context 'with invalid parameters' do
  #     it 'does not create a new CustomField' do
  #       expect {
  #         post custom_fields_url, params: { custom_field: invalid_attributes }
  #       }.to change(CustomField, :count).by(0)
  #     end

  #     it 'renders a successful response (i.e. to display the new template)' do
  #       post custom_fields_url, params: { custom_field: invalid_attributes }
  #       expect(response).to be_successful
  #     end
  #   end
  # end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {rca_id: rca2.id} }
      let(:rca2) { FactoryBot.create(:rca, methodology_id: methodology.id) }

      it 'updates the requested custom_field' do
        custom_field = CustomField.create! valid_attributes
        patch custom_field_url(custom_field), params: { custom_field: new_attributes }
        custom_field.reload
        expect(custom_field.rca).to eq rca2
      end

      it 'redirects to the custom_field' do
        custom_field = CustomField.create! valid_attributes
        patch custom_field_url(custom_field), params: { custom_field: new_attributes }
        custom_field.reload
        expect(response).to redirect_to(custom_fields_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        custom_field = CustomField.create! valid_attributes
        patch custom_field_url(custom_field), params: { custom_field: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  # describe 'DELETE /destroy' do
  #   it 'destroys the requested custom_field' do
  #     custom_field = CustomField.create! valid_attributes
  #     expect {
  #       delete custom_field_url(custom_field)
  #     }.to change(CustomField, :count).by(-1)
  #   end

  #   it 'redirects to the custom_fields list' do
  #     custom_field = CustomField.create! valid_attributes
  #     delete custom_field_url(custom_field)
  #     expect(response).to redirect_to(custom_fields_url)
  #   end
  # end

  describe 'GET /update_db' do
    pending('En attente de trouver une solution pour ce test...')
    # let(:custom_field) { CustomField.create! valid_attributes }

    # before :each do
    #   # load "#{Rails.root}/db/seed_empty.rb"
    #   FactoryBot.create(:meth_custom_field_desc)
    #   FactoryBot.create(:meth_custom_field_desc, :type_rich_text)
    #   FactoryBot.create(:meth_custom_field_desc, :type_tag)

    #   custom_field
    # end

    # after :each do
    #   # DatabaseCleaner.clean
    #   Meth::CustomFieldDesc.all do |cf|
    #     ActiveRecord::Base.connection.remove_column :custom_fields, cf.internal_name.intern
    #   end
    #   # binding.pry
    # end

    # it 'updates the database with new columns' do
    #   get custom_fields_update_db_path
    #   # binding.pry
    #   # expect(response).to redirect_to(custom_fields_url)
    #   expect(custom_field.reload).to respond_to(:custom_1)
    #   expect(custom_field).to respond_to(:custom_2)
    #   expect(custom_field).to respond_to(:custom_3)
    #   expect(custom_field).to_not respond_to(:custom_4)
    # end
  end
end
